// SplitterTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SplitterTest.h"
#include "SplitterTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSplitterTestDlg dialog

CSplitterTestDlg::CSplitterTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSplitterTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSplitterTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_dwdProgress=700;
}

void CSplitterTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSplitterTestDlg)
	DDX_Control(pDX, IDC_SP_H, m_IDC_SP_H);
	DDX_Control(pDX, IDC_SP_V, m_IDC_SP_V);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSplitterTestDlg, CDialog)
	//{{AFX_MSG_MAP(CSplitterTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_chkEnableProgress, OnchkEnableProgress)
	ON_WM_WINDOWPOSCHANGED()
	ON_BN_CLICKED(IDC_chkShowMode, OnchkShowMode)
	ON_BN_CLICKED(IDC_chkInvis, OnchkInvis)
	ON_BN_CLICKED(IDC_bnMoveWindow, OnbnMoveWindow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplitterTestDlg message handlers


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSplitterTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSplitterTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CSplitterTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	
	//  
	m_IDC_SP_H.Create(this,true,true);

	//  
	m_IDC_SP_V.Create(this,false,true);

	//    CEdit
	CEdit* pED=0;
	if(pED=(CEdit*)GetDlgItem(IDC_EDIT1)){pED->SetWindowText(" 1");}
	if(pED=(CEdit*)GetDlgItem(IDC_EDIT2)){pED->SetWindowText(" 2");}
	if(pED=(CEdit*)GetDlgItem(IDC_EDIT3)){pED->SetWindowText(" 3");}
	if(pED=(CEdit*)GetDlgItem(IDC_EDIT4)){pED->SetWindowText(" 4");}


	return TRUE;
}

BOOL CSplitterTestDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	//    CSplitter1153
	{{{
		//   
		BEGINMAP_for_CSplitter1153(IDC_SP_H)
		SWITCH_for_CSplitter1153
		{
			case pSP->IDmess_OnChangePos:
			{
				RefreshControlsPositions();
			}
			break;

			//case...
		}
		ENDMAP_for_CSplitter1153_and_return1_if_processed
	}}}

	//    CSplitter1153
	{{{
		//   
		BEGINMAP_for_CSplitter1153(IDC_SP_V)
		SWITCH_for_CSplitter1153
		{
			case pSP->IDmess_OnChangePos:
			{
				RefreshControlsPositions();
			}
			break;

			//case...
		}
		ENDMAP_for_CSplitter1153_and_return1_if_processed
	}}}



	return CDialog::OnNotify(wParam, lParam, pResult);
}

//  
void CSplitterTestDlg::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	CDialog::OnWindowPosChanging(lpwndpos);
}

void CSplitterTestDlg::OnMouseMove(UINT nFlags, CPoint point) 
{

	if(m_IDC_SP_H.GetEnableProgress())
	{
		m_IDC_SP_H.SetProgressValueCurr_RetResult(m_dwdProgress);
		m_dwdProgress--;
	}

	if(m_IDC_SP_V.GetEnableProgress())
	{
		m_IDC_SP_V.SetProgressValueCurr_RetResult(m_dwdProgress);
		m_dwdProgress--;
	}

	if(((int)m_dwdProgress)<0)m_dwdProgress=1000;
	
	CDialog::OnMouseMove(nFlags, point);
}

// ""
void CSplitterTestDlg::OnchkEnableProgress() 
{
	//  
	CButton* pbn=(CButton*)GetDlgItem(IDC_chkEnableProgress);
	if(pbn)
	{
		if(pbn->GetCheck())
		{
			//
			m_IDC_SP_H.SetEnableProgress(true);
			m_IDC_SP_H.SetProgressValueMin_RetResult(0);
			m_IDC_SP_H.SetProgressValueMax_RetResult(1000);
			m_IDC_SP_H.SetProgressValueCurr_RetResult(m_dwdProgress);

			m_IDC_SP_V.SetEnableProgress(true);
			m_IDC_SP_V.SetProgressValueMin_RetResult(0);
			m_IDC_SP_V.SetProgressValueMax_RetResult(1000);
			m_IDC_SP_V.SetProgressValueCurr_RetResult(m_dwdProgress);
		}
		else
		{
			//
			m_IDC_SP_H.SetEnableProgress(false);
			m_IDC_SP_V.SetEnableProgress(false);
		}
	}
}

//     
void CSplitterTestDlg::RefreshControlsPositions(bool bInitSplittersPos)
{

	//      
	int nXmin,nXmax,nYmin,nYmax;

	//   
	//(    ,  
	//   == 0,0)
	CRect parClR;
	GetClientRect(&parClR);

	//    .
	//      
	//( " ")
	::MapWindowPoints(m_hWnd,0,(POINT*)&parClR,2);

	//   (     def_MW)
	CPoint ClientLefTop(parClR.left,parClR.top);

	//   (  rTemp  
	//    
	//  MoveWindow     
	// rTemp)
	CRect rTemp;

	// -       
	//  MoveWindow
	#define def_MW(pWnd,i_rect) \
			/*    */\
			rTemp=(i_rect)-ClientLefTop;\
			/**/\
			(pWnd)->MoveWindow(&rTemp,1)
	


	// 
	int  nTopBorder=30;

	//
	nYmin = parClR.top;
	nYmax = parClR.bottom;
	nXmin = parClR.left;
	nXmax = parClR.right;


	//  
	BYTE byMode=0;
	{
		CButton* pbn=(CButton*)GetDlgItem(IDC_chkShowMode);
		if(!pbn)return;
		byMode=(pbn->GetCheck()?1:0);
	};




	//1)     -  ""   

	CRect rV;//     
	CRect rH;//     

	{

		//     
		{
			m_IDC_SP_V.GetWindowRect(&rV);
			//rV.left=	   
			//rV.right=	  
			rV.top=nYmin+nTopBorder;
			rV.bottom=nYmax;

			//   
			def_MW(&m_IDC_SP_V,rV);

			//     
			m_IDC_SP_V.RefreshCurrentRectFromParent();

			//   
			if(byMode==0)
			{
				m_IDC_SP_V.SetEscapesValues(0,0);
			}
			else
			{
				//    4 
				m_IDC_SP_V.SetEscapesValues(0,50);
			}
		}

		//     
		m_IDC_SP_V.GetWindowRect(&rV);

		//byMode==0 -      ,
		//    .
		//byMode==1 -      
		{
			m_IDC_SP_H.GetWindowRect(&rH);
			if(byMode==0)
			{
				//:  "-"
				//rH.top=		   
				//rH.bottom=	   
				rH.left=nXmin;
				rH.right=nXmax;
			}
			else
			{
				//rH.top=		   
				//rH.bottom=	   
				rH.left=nXmin;
				rH.right=rV.left;
			}

			//   
			def_MW(&m_IDC_SP_H,rH);

			//     
			m_IDC_SP_H.RefreshCurrentRectFromParent();

			m_IDC_SP_H.SetEscapesValues(nTopBorder,0);//   
		}

		//     
		m_IDC_SP_H.GetWindowRect(&rH);
	}

	//2)      
	//       

	switch(byMode)
	{
		default:
		case 0://:  "-"
		{
			CEdit* pED=0;
			CRect rED;

			//IDC_EDIT1   
			pED=(CEdit*)GetDlgItem(IDC_EDIT1);
			if(pED)
			{
				rED.left=nXmin;
				rED.top=rV.top;
				rED.right=rV.left;
				rED.bottom=rH.top;
				def_MW(pED,rED);
			}

			//IDC_EDIT2   
			pED=(CEdit*)GetDlgItem(IDC_EDIT2);
			if(pED)
			{
				rED.left=nXmin;
				rED.top=rH.bottom;
				rED.right=rV.left;
				rED.bottom=nYmax;
				def_MW(pED,rED);
			}

			//IDC_EDIT3   
			pED=(CEdit*)GetDlgItem(IDC_EDIT3);
			if(pED)
			{
				rED.left=rV.right;
				rED.top=rV.top;
				rED.right=nXmax;
				rED.bottom=rH.top;
				def_MW(pED,rED);
			}

			//IDC_EDIT4   
			pED=(CEdit*)GetDlgItem(IDC_EDIT4);
			if(pED)
			{
				rED.left=rV.right;
				rED.top=rH.bottom;
				rED.right=nXmax;
				rED.bottom=nYmax;
				def_MW(pED,rED);
			}
		}
		break;

		case 1://: 2  ,    
		{
			CEdit* pED=0;
			CRect rED;

			//IDC_EDIT1   
			pED=(CEdit*)GetDlgItem(IDC_EDIT1);
			if(pED)
			{
				rED.left=nXmin;
				rED.top=rV.top;
				rED.right=rV.left;
				rED.bottom=rH.top;
				def_MW(pED,rED);
			}

			//IDC_EDIT2   
			pED=(CEdit*)GetDlgItem(IDC_EDIT2);
			if(pED)
			{
				rED.left=nXmin;
				rED.top=rH.bottom;
				rED.right=rV.left;
				rED.bottom=nYmax;
				def_MW(pED,rED);
			}

			//IDC_EDIT3  ( -  )
			pED=(CEdit*)GetDlgItem(IDC_EDIT3);
			if(pED)
			{
				rED.left=0;
				rED.top=0;
				rED.right=0;
				rED.bottom=0;
				def_MW(pED,rED);
			}

			//IDC_EDIT4      40
			pED=(CEdit*)GetDlgItem(IDC_EDIT4);
			if(pED)
			{
				rED.left=rV.right;
				rED.top=rV.top;
				rED.right=rED.left+40;
				rED.bottom=nYmax;
				def_MW(pED,rED);
			}
		}
		break;
	}

	Invalidate(0);

	#undef def_MW
}

void CSplitterTestDlg::OnchkInvis() 
{
	//  
	CButton* pbn=(CButton*)GetDlgItem(IDC_chkInvis);
	if(pbn)
	{
		if(pbn->GetCheck())
		{
			// 
			m_IDC_SP_H.SetInvisibleMode(true);
			m_IDC_SP_V.SetInvisibleMode(true);
		}
		else
		{
			m_IDC_SP_H.SetInvisibleMode(false);
			m_IDC_SP_V.SetInvisibleMode(false);
		}
	}
	
}

void CSplitterTestDlg::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	CDialog::OnWindowPosChanged(lpwndpos);

	if(0)
	{
		//  
		m_IDC_SP_H.RefreshCurrentRectFromParent();
		m_IDC_SP_V.RefreshCurrentRectFromParent();
	}
	else
	{
		//   
		RefreshControlsPositions();
	}
}


void CSplitterTestDlg::OnchkShowMode() 
{
	RefreshControlsPositions();
}

//  
void CSplitterTestDlg::OnbnMoveWindow() 
{
	m_IDC_SP_H.MoveWindow_SetTheMinimumMainCoordinate(100);
	m_IDC_SP_V.MoveWindow_SetTheMinimumMainCoordinate(120);
	RefreshControlsPositions();
}
